// from Spring 2003 final exam, problem 3

import java.util.*;

public class CleanCircle {
    
    public static void main(String[] args) {
        
        // Create list with sentinel as first node:
        Circle c = new Circle(); // create Circle with sentinel
        Node s = c.sentinel;     // set reference s to sentinel node
        
        // Add nodes to list:
        Node n = s; // node so far
        s.next = n;
        n.prev = s;
        for (int i=1;i<=Integer.parseInt(args[0]);i++) {
            Node tmp = new Node();
            n.next = tmp;           
            tmp.prev = n;
            n = tmp;
        }
        n.next = s;
        s.prev = n;
	
        // Display initial list:
        System.out.println(c);
	
        // Remove 0s from list:
        Iterator i = c.new CircleIterator();
        while( i.hasNext() ) {
            Integer next = (Integer) i.next(); // System.out.println(next);
            if (next.equals(new Integer(0)))
                i.remove();
        }
        System.out.println(c);

    } // Method main   
    
} // Class TestCircle

class Node {
    public Node next;
    public Node prev;
    public Object data;
    public Node() { data = new Integer(MyMath.randInt(0,3)); }
    public String toString() { return ""+data; }
} // Class Node

class MyMath {
    public static int randInt(int low, int high) {
        return (int) (Math.random()*(high-low+1)) + (int) low;
    }
}

class Circle {
    public Node sentinel; 
    
    Circle() {                     
        sentinel = new Node();     // create sentinel with arbitrary value
        sentinel.next = sentinel;  
        sentinel.prev = sentinel;  
    } 
    
    public class CircleIterator implements Iterator {
        private Node cursor;   // current finger into list

        public CircleIterator( ) {
            cursor = sentinel.next;
        }

        public boolean hasNext( ) {
            return cursor != sentinel;
        }

        public Object next( ) {
            Object d = cursor.data;
            cursor = cursor.next;
            return d;       
        }

        // remove called *only* after hasNext and next
        public void remove( ) {
            Node previous = cursor.prev.prev; // assuming at least 1 node besides sentinel!
            previous.next = cursor;           // previous stays in place
            cursor.prev = previous;
        }

        
    } // Class CircleIterator
    
    public String toString() {
        String s = "";
        Iterator i = new CircleIterator();
        while( i.hasNext() ) s += i.next();
        return s;
    }
    
    
} // Class Circle
