// iterator with anonymous class

import java.util.*;

public class IteratorAnon {
    public static void main(String[] args) {
   	Comparable target = 42; // item to search for
	Data values = new Data(1000,0,100); // data for searching
	boolean result = linearSearch(values.iterate(),target);
	System.out.println("Is "+target+" found? "+result);
    }

    private static boolean linearSearch(Iterator vals, Comparable v) {
	while(vals.hasNext()) {
	    Object current = vals.next();
	    if ( ((Comparable) current).compareTo(v) == 0 )
		return true;
	}
	return false;
    }
}

class Data {
    private Comparable[] values;

    public Data(int size, int min, int max) {
	values = new Comparable[size];
	for (int i=0; i<size; i++)
	    values[i]=randInt(min,max);
    }
    
    public Iterator iterate() {
	return 
	    new Iterator() {
		private int cursor;
		public boolean hasNext() {
		    return (cursor < values.length) ;
		}
		public Object next() {
		    return values[cursor++];
		}
		public void remove() {}
	    }; 
    }
    
    public String toString() {
	String s="[";
	for (int i=0; i<values.length; i++) {
	    s += values[i];
	    if (i < values.length-1 )
		s+=", ";
	}
	s+="]";
	return s;
    }
    
    private static int randInt(int min, int max) {
	return (int) (Math.random()*(max-min+1)) + min; 
    }
    
    public Comparable[] getData() { return values; }
    
}

