// original version: Paul Chew, October 2006
// added Iterator and test code: David I. Schwartz, October 2006

import java.util.*;

public class StackIterator {
    public static void main(String[] args) {

	ListStack s = new ListStack();
	s.push(1); s.push(2); s.push(3);
	
	// output in order from top to bottom of stack:
	Iterator i = s.new StackIterator();
	while (i.hasNext())
	    System.out.println(i.next());
    }

}

interface Stack {
    public void push (Object x);
    public Object pop ();
    public Object peek ();
    public boolean isEmpty ();
    public void makeEmpty ();
}

class ListStack implements Stack {
    
    private Node head = null;  // Head of list that holds the Stack

    public void push (Object x) {head = new Node(x, head);}
    public Object pop () {Node temp = head; head = head.next; return temp.data;}
    public Object peek () {return head.data;}
    public boolean isEmpty () {return head == null;}
    public void makeEmpty () {head = null;}
    
    public class StackIterator implements Iterator {
	    
	    private Node cursor = head;
	    
	    public boolean hasNext() {
		return cursor!=null;
	    }
	    
	    public Object next() {
		Object d = cursor.data;
		cursor = cursor.next;
		return d;
	    }
	    
	    public void remove() {
		throw new UnsupportedOperationException(); 
	    }
	    
    }

}

class Node {
    public Object data;       // Data field
    public Node next;         // Next node of list
    
    public Node (Object data, Node next) {this.data = data; this.next = next;}
    public String toString() { return ""+data; }
}
